package com.cn.listener;

import com.cn.model.ChatGroup;
import org.jim.common.ImAio;
import org.jim.common.ImPacket;
import org.jim.common.ImSessionContext;
import org.jim.common.packets.*;
import org.jim.server.enums.ServiceAccountOfflineTypeEnum;
import org.jim.server.enums.VisitTypeEnum;
import org.jim.server.listener.ImGroupListener;
import org.tio.core.ChannelContext;

/**
 * @author Darren
 * @date 2020/2/6 15:53
 */
public class IMChatGroupListener extends ImGroupListener {


    @Override
    public void onAfterUnbind(ChannelContext channelContext, String group) throws Exception {

        ImSessionContext imSessionContext = (ImSessionContext)channelContext.getAttribute();
        ExitGroupNotifyRespBody exitGroupNotifyRespBody = new ExitGroupNotifyRespBody();
        exitGroupNotifyRespBody.setGroup(group);
        Client client = imSessionContext.getClient();
        if(client == null){
            return;
        }
        User clientUser = client.getUser();
        if(clientUser == null) {
            return;
        }
        //访问类型 (SERVICEACCOUNT 客服 / CUSTOMER 客户 / VISITOR 游客)
        String visitType = clientUser.getVisitType();
        if( !VisitTypeEnum.SERVICEACCOUNT.equals(visitType) ){
            //客户 / 游客 关闭连接 退出群组 后 删除临时群组
            ChatGroup chatGroup = ChatGroup.dao.findById(group);
            Integer serviceAccountType = chatGroup.getInt("service_account_type");
            if( ServiceAccountOfflineTypeEnum.NO.getKey() == serviceAccountType ){
                //在线群组 才可以删除
                ChatGroup.dao.deleteById(group);
            }
        }

        User notifyUser = new User(clientUser.getId(),clientUser.getNick());
        exitGroupNotifyRespBody.setUser(notifyUser);

        RespBody respBody = new RespBody(Command.COMMAND_EXIT_GROUP_NOTIFY_RESP,exitGroupNotifyRespBody);
        ImPacket imPacket = new ImPacket(Command.COMMAND_EXIT_GROUP_NOTIFY_RESP, respBody.toByte());
        ImAio.sendToGroup(group, imPacket);
    }


}
